spandsp: tone_generate.c File Reference

spandsp 0.0.6

Macros | Functions
tone_generate.c File Reference
`#include <inttypes.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include <stdio.h>`
`#include <time.h>`
`#include <fcntl.h>`
`#include "floating_fudge.h"`
`#include "spandsp/telephony.h"`
`#include "spandsp/fast_convert.h"`
`#include "spandsp/dc_restore.h"`
`#include "spandsp/complex.h"`
`#include "spandsp/dds.h"`
`#include "spandsp/tone_generate.h"`
`#include "spandsp/private/tone_generate.h"`

## Macros
#define | M_PI 3.14159265358979323846264338327

## Functions
tone_gen_descriptor_t * | tone_gen_descriptor_init (tone_gen_descriptor_t *s, int f1, int l1, int f2, int l2, int d1, int d2, int d3, int d4, int repeat)
| Create a tone generator descriptor.
void | tone_gen_descriptor_free (tone_gen_descriptor_t *s)
int | tone_gen (tone_gen_state_t *s, int16_t amp[], int max_samples)
tone_gen_state_t * | tone_gen_init (tone_gen_state_t *s, tone_gen_descriptor_t *t)
int | tone_gen_release (tone_gen_state_t *s)
int | tone_gen_free (tone_gen_state_t *s)

## Function Documentation

## ◆ tone_gen_descriptor_init()

tone_gen_descriptor_t * tone_gen_descriptor_init | ( | tone_gen_descriptor_t * | s,
|  | int | f1,
|  | int | l1,
|  | int | f2,
|  | int | l2,
|  | int | d1,
|  | int | d2,
|  | int | d3,
|  | int | d4,
|  | int | repeat
| ) |  |

Create a tone generator descriptor.

Create a tone generator descriptor

Parameters

  s | The descriptor
  f1 | The first frequency, in Hz
  l1 | The level of the first frequency, in dBm0
  f2 | 0 for no second frequency, a positive number for the second frequency, in Hz, or a negative number for an AM modulation frequency, in Hz
  l2 | The level of the second frequency, in dBm0, or the percentage modulation depth for an AM modulated tone.
  d1 | x
  d2 | x
  d3 | x
  d4 | x
  repeat | x

References dds_phase_rate(), dds_phase_ratef(), dds_scaling_dbm0(), and dds_scaling_dbm0f().

Referenced by adsi_tx_init(), and r2_mf_tx_init().